@ECHO OFF
ECHO OFF
CLS
COLOR 0A

:INIT
SET /A ERROR=0
SET /A GAME=0
SET /A DEBUG=0
COLOR 0A
CLS
GOTO MENU
GOTO ERROR

:MENU
CLS
SET /A ERROR=3
COLOR 0A
ECHO (C)AiO Softworks 2015
ECHO TextEngine v1.42A BY FAMICOMASTER
ECHO PICK AN OPTION=
ECHO  1. NEW GAME
ECHO  2. LOAD GAME
ECHO  3. VIEW README
ECHO  4. EXIT
SET /P MENU=?=
IF %MENU%==0 GOTO DEBUG
IF %MENU%==1 GOTO NEW
IF %MENU%==2 GOTO LOAD
IF %MENU%==3 GOTO README
IF %MENU%==4 GOTO EXIT
ECHO INVALID CHOICE!
ECHO PRESS ANY KEY TO CONTINUE...
PAUSE>NUL
GOTO MENU
GOTO ERROR

:EXIT
CLS
SET /A ERROR=4
COLOR FA
ECHO.
ECHO ARE YOU SURE?
SET /P EXIT=1 OR 2?=
IF %EXIT%==1 GOTO EXITA
IF %EXIT%==2 GOTO MENU
GOTO ERROR

:EXITA
ECHO.
ECHO EXITING...
EXIT

:README
CLS
SET /A ERROR=5
COLOR F0
TYPE C:\TE_RA\README.TXT
ECHO.
ECHO PRESS ANY KEY TO CONTINUE...
PAUSE>NUL
GOTO MENU

:DEBUG
CLS
SET /A ERROR=6
SET /A DEBUG=1
COLOR 0A
ECHO DEBUG MENU ACTIVE
ECHO PRESS TO TEST...
ECHO  0 DEBUG
ECHO  1 VARIABLES
ECHO  2 MENU
ECHO  3 MAIN MENU
ECHO  4 BATTLES
ECHO  5 README
ECHO  6 ERRORS
ECHO  7 EXIT
ECHO  8 LOAD
ECHO  9 NEW
ECHO  A SAVE
ECHO  B INTRO
SET /P DEBUG=?=
IF %DEBUG%==0 GOTO DEBUG
IF %DEBUG%==1 GOTO VAR
IF %DEBUG%==2 GOTO MENU
IF %DEBUG%==3 GOTO MAIN
IF %DEBUG%==4 GOTO
IF %DEBUG%==5 GOTO README
IF %DEBUG%==6 GOTO ERROR
IF %DEBUG%==7 GOTO EXIT
IF %DEBUG%==8 GOTO LOAD
IF %DEBUG%==9 GOTO NEW
IF %DEBUG%==A GOTO SAVE
IF %DEBUG%==B GOTO INTRO
ECHO INVALID FUNCTION.
ECHO PRESS ANY KEY TO CONTINUE...
PAUSE>NUL
GOTO DEBUG

:ERROR
CLS
COLOR 04
ECHO AN ERROR OCCURED IN THE PROGRAM AT=
ECHO  %ERROR%
ECHO DEBUG IS ON=
ECHO  %DEBUG%
ECHO PLEASE REPORT THIS ERROR A.S.A.P.!
ECHO PRESS ANY KEY TO CONTINUE...
PAUSE>NUL
GOTO MENU

:VAR
CLS
SET /A ERROR=7
ECHO VARIABLES ARE=
ECHO  ERROR=%ERROR%
ECHO  DEBUG=%DEBUG%
ECHO  GAME=%GAME%
ECHO  SAVE=%SAVE%
ECHO  LOAD=%LOAD%
ECHO  NAME=%NAME%
ECHO  GOLD=%GOLD%
ECHO  PHP=%PHP%
ECHO  MHP=%MHP%
ECHO PRESS ANY KEY TO CONTINUE...
PAUSE>NUL
GOTO DEBUG

:NEW
SET /A ERROR=8
CLS
COLOR 0A
TYPE C:\TE_RA\LIST.LST
ECHO.
SET /P GAME=?=
GOTO STORY

:STORY
SET /A ERROR=9
SET /A NAME=0
SET /A PHP=50
SET /A GOLD=100
SET /A MHP=25
SET /A MOVE=0
CLS
COLOR 0F
TYPE C:\TE_RA\%GAME%\0.GAM
ECHO.
ECHO.
PAUSE>NUL
TYPE C:\TE_RA\%GAME%\1.GAM
ECHO.
ECHO.
PAUSE>NUL
TYPE C:\TE_RA\%GAME%\2.GAM
ECHO.
ECHO.
PAUSE>NUL
TYPE C:\TE_RA\%GAME%\3.GAM
ECHO.
ECHO.
PAUSE>NUL
TYPE C:\TE_RA\%GAME%\N.GAM
ECHO.
ECHO.
SET /P NAME=?=
GOTO MAIN

:MAIN
SET /A ERROR=10
SET /A MAIN=6
COLOR 0A
ECHO.
ECHO CHOOSE AN ACTION=
ECHO PRESS THE NUMBER!
ECHO  1 MOVE ONE SPACE
ECHO  2 GOTO THE SHOP
ECHO  3 CHECK PLAYER INFO
ECHO  4 LOOK AROUND
ECHO  5 SAVE AND EXIT
SET /P MAIN=?=
IF %MAIN%==0 GOTO DEBUG
IF %MAIN%==1 GOTO MOVE
IF %MAIN%==2 GOTO SHOP
IF %MAIN%==3 GOTO INFO
IF %MAIN%==4 GOTO LOOK
IF %MAIN%==5 GOTO SAVE
ECHO.
ECHO INVALID CHOICE.
GOTO MAIN
GOTO ERROR

:INFO
SET /A ERROR=11
COLOR 0A
ECHO.
ECHO PLAYER INFORMATION
ECHO  %NAME%'S HEALTH=
ECHO   %PHP% OF 50
ECHO  %NAME%'S GOLD=
ECHO   %GOLD%
ECHO  %NAME%'S POSITION=
ECHO   %MOVE% OF 6
GOTO MAIN

:SHOP
SET /A ERROR=12
COLOR 0A
ECHO.
ECHO THE SHOP'S CLOSED! COME BACK LATER!
ECHO.
GOTO MAIN

:LOOK
SET /A ERROR=13
COLOR 0A
ECHO.
ECHO YOU LOOK AROUND YOU.
ECHO.
TYPE C:\TE_RA\%GAME%\%MOVE%.MAP
ECHO.
GOTO MAIN

:SAVE
SET /A ERROR=14
COLOR 09
ECHO.
ECHO WHAT FILE DO YOU WANT TO SAVE TO?
SET /P SAVE=?=
ECHO SAVING, PLEASE WAIT...

ECHO %SAVE% >> C:\TE_RA\SAVE\%SAVE%.SAV
ECHO %GAME% >> C:\TE_RA\SAVE\%SAVE%.SAV
ECHO %NAME% >> C:\TE_RA\SAVE\%SAVE%.SAV
ECHO %MOVE% >> C:\TE_RA\SAVE\%SAVE%.SAV
ECHO %GOLD% >> C:\TE_RA\SAVE\%SAVE%.SAV
ECHO %PHP% >> C:\TE_RA\SAVE\%SAVE%.SAV
ECHO %ERROR% >> C:\TE_RA\SAVE\%SAVE%.SAV
ECHO TextEngine 1.1A SAVE FILE >> C:\TE_RA\SAVE\%SAVE%.SAV
ECHO SAVE COMPLETE!
ECHO PRESS ANY KEY TO EXIT...
PAUSE>NUL
GOTO EXIT

:MOVE
SET /A ERROR=15
COLOR 0A
ECHO.
ECHO YOU MOVE ONE UNIT IN THE WORLD.
ECHO PLEASE WAIT, PROCESSING...
GOTO MOVEA

:MOVEA
SET /A ERROR=16
SET /A MOVE=%MOVE%+1
IF /I %MOVE% GTR 7 GOTO MOVEB
IF /I %MOVE% LSS 0 GOTO MOVEC
GOTO MOVED

:MOVEB
SET /A ERROR=17
SET /A MOVE=%MOVE%-1
IF /I %MOVE% LSS 0 GOTO MOVEC
GOTO MOVED

:MOVEC
SET /A ERROR=18
SET /A MOVE=%MOVE%+1
IF /I %MOVE% GTR 7 GOTO MOVEB
GOTO MOVED

:MOVED
SET /A ERROR=19
SET /A CFA=%RANDOM%
IF /I %CFA% LSS 2048 GOTO MONSTER
IF /I %CFA% LSS 8192 GOTO MONSTER
GOTO MAIN

:MONSTER
SET /A ERROR=20
SET /A MHP=25
SET /A TYPE=%RANDOM%
IF /I %CFA% LSS 512 GOTO TYPEF
IF /I %CFA% LSS 1024 GOTO TYPEA
IF /I %CFA% LSS 2048 GOTO TYPEB
IF /I %CFA% LSS 4096 GOTO TYPEC
IF /I %CFA% LSS 8192 GOTO TYPED
IF /I %CFA% LSS 16384 GOTO TYPEE
GOTO MONSTER

:TYPEF
SET /A ERROR=21
SET /A TYPE=0
GOTO ATTACK

:TYPEA
SET /A ERROR=22
SET /A TYPE=1
GOTO ATTACK

:TYPEB
SET /A ERROR=23
SET /A TYPE=2
GOTO ATTACK

:TYPEC
SET /A ERROR=24
SET /A TYPE=3
GOTO ATTACK

:TYPED
SET /A ERROR=25
SET /A TYPE=4
GOTO ATTACK

:TYPEE
SET /A ERROR=26
SET /A TYPE=5
GOTO ATTACK

:ATTACK
SET /A ERROR=27
ECHO.
ECHO A VISCIOUS
TYPE C:\TE_RA\%GAME%\%TYPE%.MON
ECHO ATTACKS YOU!
GOTO CHK

:CHK
SET /A ERROR=30
SET /A CHK=%RANDOM%
IF /I %CHK% LSS 16384 GOTO MONA
IF /I %CHK% LSS 32767 GOTO PLY
GOTO CHK

:MONA
SET /A ERROR=31
ECHO.
ECHO IT GETS FIRST ATTACK!
GOTO MON

:MON
SET /A ERROR=28
SET /A MON=%RANDOM%
IF /I %MON% LSS 2048 GOTO MATK
IF /I %MON% LSS 4096 GOTO MDEF
IF /I %MON% LSS 8192 GOTO MRUN
GOTO MON

:MATK
SET /A ERROR=29
ECHO.
ECHO IT ATTACKS!
GOTO MATKA

:MATKA
SET /A ERROR=32
SET /A MATK=%RANDOM%
IF /I %MATK% LSS 256 GOTO MATKE
IF /I %MATK% LSS 4096 GOTO MATKB
IF /I %MATK% LSS 8192 GOTO MATKC
IF /I %MATK% LSS 16384 GOTO MATKD
GOTO MATKA

:MATKE
SET /A ERROR=34
SET /A MATK=0
GOTO MATKF

:MATKB
SET /A ERROR=33
SET /A MATK=1
GOTO MATKF

:MATKC
SET /A ERROR=35
SET /A MATK=3
GOTO MATKF

:MATKD
SET /A ERROR=36
SET /A MATK=6
GOTO MATKF

:MATKF
SET /A ERROR=37
ECHO.
ECHO IT DOES %MATK% DAMAGE TO YOU!
SET /A PHP=%PHP%-%MATK%
ECHO BRINGING YOUR HP TO %PHP%!
GOTO MATKG

:MDEF
SET /A ERROR=38
ECHO.
ECHO IT DEFENDS!
GOTO MDEFA

:MDEFA
SET /A ERROR=39
SET /A MDEF=2
ECHO.
ECHO IT GAINS %MDEF% HP!
SET /A MHP=%MHP%+%MDEF%
ECHO GIVING IT %MHP%!
GOTO BMENU

:MRUN
SET /A ERRROR=40
ECHO.
ECHO IT TRIES TO RUN AWAY!
GOTO MRUNA

:MRUNA
SET /A ERROR=41
SET /A MRUN=%RANDOM%
IF /I %MRUN% LSS 1024 GOTO MRUNB
IF /I %MRUN% LSS 2048 GOTO MRUNB
IF /I %MRUN% GTR 2048 GOTO MRUNC
GOTO MRUNA

:MRUNB
SET /A ERROR=42
SET /A MRUN=1
GOTO MRUND

:MRUNC
SET /A ERROR=43
SET /A MRUN=0
GOTO MRUND

:MRUND
SET /A ERROR=44
IF %MRUN%==1 GOTO MRUNE
IF %MRUN%==0 GOTO MRUNF
GOTO ERROR

:MRUNF
SET /A ERROR=45
ECHO.
ECHO BUT IT FAILS!
GOTO BMENU

:MRUNE
SET /A ERROR=46
ECHO.
ECHO AND IT SUCCEDES!
GOTO MAIN

:BMENU
SET /A ERROR=47
ECHO.
ECHO BATTLE MENU=
ECHO PICK AN ACTION=
ECHO  1. ATTACK
ECHO  2. DEFEND
ECHO  3. CHECK INFO
ECHO  4. FLEE
SET /P BMENU=?=
IF %BMENU%==0 GOTO DEBUG
IF %BMENU%==1 GOTO ATK
IF %BMENU%==2 GOTO DEF
IF %BMENU%==3 GOTO BINFO
IF %BMENU%==4 GOTO RUN
ECHO INVALID CHOICE!
GOTO BMENU

:BINFO
SET /A ERROR=48
ECHO.
ECHO BATTLE INFO=
ECHO  %NAME%'S HP=
ECHO   %PHP%
ECHO  %NAME%'S GOLD=
ECHO   %GOLD%
ECHO  MONSTER'S HP=
ECHO   %MHP%
ECHO  MONSTER TYPE=
ECHO.
TYPE C:\TE_RA\%GAME%\%TYPE%.MON
ECHO.
GOTO BMENU

:DEF
SET /A ERROR=49
SET /A DEF=2
ECHO.
ECHO %NAME% GAINS %DEF% HP!
SET /A PHP=%PHP%+%DEF%
ECHO BRINGING IT TO %PHP%!
GOTO MONB

:MONB
SET /A ERROR=50
ECHO.
ECHO IT IS NOW THE VISCIOUS
ECHO.
ECHO.
TYPE C:\TE_RA\%GAME%\%TYPE%.MON
ECHO 'S TURN!
GOTO MON

:ATK
SET /A ERROR=51
ECHO.
ECHO YOU ATTACK!
GOTO ATKA

:ATKA
SET /A ERROR=52
SET /A ATK=%RANDOM%
IF /I %ATK% LSS 256 GOTO ATKE
IF /I %ATK% LSS 4096 GOTO ATKB
IF /I %ATK% LSS 8192 GOTO ATKC
IF /I %ATK% LSS 16384 GOTO ATKD
GOTO ATKA

:ATKE
SET /A ERROR=53
SET /A ATK=0
GOTO ATKF

:ATKB
SET /A ERROR=54
SET /A ATK=1
GOTO ATKF

:ATKC
SET /A ERROR=55
SET /A ATK=3
GOTO ATKF

:ATKD
SET /A ERROR=56
SET /A ATK=6
GOTO ATKF

:ATKF
SET /A ERROR=57
ECHO.
ECHO YOU DO %ATK% DAMAGE TO IT!
SET /A MHP=%MHP%-%ATK%
ECHO BRINGING IT TO %MHP%!
GOTO ATKG

:ATKG
SET /A ERROR=58
IF /I %MHP% LSS 1 GOTO PWIN
GOTO MONB

:MATKG
SET /A ERROR=59
IF /I %PHP% LSS 1 GOTO GAMEOVER
GOTO BMENU

:RUN
SET /A ERROR=60
ECHO.
ECHO YOU TRY TO FLEE!
GOTO RUNA

:RUNA
SET /A ERROR=61
SET /A RUN=%RANDOM%
IF /I %RUN% LSS 1024 GOTO RUNB
IF /I %RUN% LSS 2048 GOTO RUNB
IF /I %RUN% GTR 2048 GOTO RUNC
GOTO RUNA

:RUNB
SET /A ERROR=62
SET /A RUN=1
GOTO RUND

:RUNC
SET /A ERROR=63
SET /A M=RUN=0
GOTO RUND

:RUND
SET /A ERROR=64
IF %RUN%==1 GOTO RUNE
IF %RUN%==0 GOTO RUNF
GOTO ERROR

:RUNF
SET /A ERROR=65
ECHO.
ECHO BUT YOU FAIL!
GOTO MONB

:RUNE
SET /A ERROR=66
ECHO.
ECHO AND YOU SUCCEDE!
GOTO MAIN

:LOAD
CLS
SET /A ERROR=67
COLOR 0B
ECHO.
ECHO FILES=
DIR C:\TE_RA\SAVE\
ECHO WHICH FILE TO LOAD?
SET /P LOAD=?=
ECHO LOADING...
GOTO LOADA

:LOADA
CLS
SET /A ERROR=68
COLOR 0A
ECHO.
TYPE C:\TE_RA\SAVE\%LOAD%.SAV
ECHO.
ECHO.
ECHO LOAD FUNCTION NOT AVAILABLE!
ECHO PRESS ANY KEY TO RETURN TO THE MENU...
PAUSE>NUL
GOTO MENU

:GAMEOVER
SET /A ERROR=69
COLOR 40
ECHO.
ECHO YOU DIED IN A FEROCIOUS BATTLE WITH THE
TYPE C:\TE_RA\%GAME%\%TYPE%.MON
ECHO YOU WILL BE REMEMBERED FOR YOUR HEROIC
ECHO ACTS FOR ALL OF ETERNITY!
ECHO PRESS ANY KEY TO CONTINUE...
PAUSE>NUL
GOTO MENU

:PWIN
SET /A ERROR=70
COLOR 0A
ECHO.
ECHO YOU KILLED THE VISCIOUS
ECHO.
TYPE C:\TE_RA\%GAME%\%TYPE%.MON
ECHO !
GOTO MAIN

GOTO ERROR
EXIT